var _ = require('lodash');
var classNames = require('classnames');
var React = require('react');

var ConfigFieldCheckbox = React.createClass({
  handleOnClick: function() {
    this.refs.checkbox.getDOMNode().checked = !this.refs.checkbox.getDOMNode().checked;
    this.handleOnChange();
  },

  handleOnChange: function() {
    var val = this.refs.checkbox.getDOMNode().checked ? '1' : '0';
    if (this.props.handleChange) {
      this.props.handleChange(this.props.name, val);
    }
  },

  render: function() {
    var val = _.get(this.props, 'value', null);
    if (!val || val.length === 0) {
      val = this.props.default;
    }
    var checked = val === '1';

    var inputClasses = classNames('btn', 'btn-default', {
      'active': checked,
      'inactive': !checked,
      'readonly': this.props.readOnly
    });

    var iconClasses = classNames('fa', {
      'fa-check-square-o': checked,
      'fa-square-o': !checked
    });

    return (
      <div className="field field-type-checkbox">
        <div className="input input-type-checkbox">
          <span className="button-checkbox">
            <button
              type="button"
              disabled={this.props.readOnly}
              onClick={this.handleOnClick}
              className={inputClasses}>
              <i className={iconClasses}></i> {this.props.title}
            </button>
            <input
              ref="checkbox"
              type="checkbox"
              name={this.props.name}
              value="1"
              checked={checked}
              onChange={this.handleOnChange}
              className="hidden" />
          </span>
        </div>
      </div>
    );
  }
});

module.exports = ConfigFieldCheckbox;
