var _ = require('lodash');
var classNames = require('classnames');
var React = require('react');

var ConfigFieldRadio = React.createClass({
  handleOnClick: function() {
    if (!this.refs.radio.getDOMNode().checked) {
      this.refs.radio.getDOMNode().checked = true;
      this.handleOnChange();
    }
  },

  handleOnChange: function() {
    var val = this.refs.radio.getDOMNode().checked ? '1' : '0';
    if (val === '1' && this.props.handleChange) {
      this.props.handleChange(this.props.name, val);
    }
  },

  render: function() {
    var val = _.get(this.props, 'value', null);
    if (!val || val.length === 0) {
      val = this.props.default;
    }
    var checked = val === this.props.name;

    var inputClasses = classNames('btn', 'btn-default', {
      'active': checked,
      'inactive': !checked,
      'readonly': this.props.readOnly
    });

    var iconClasses = classNames('fa', {
      'fa-dot-circle-o': checked,
      'fa-circle-o': !checked
    });

    return (
      <div className="field field-type-radio">
        <div className="input input-type-radio">
          <span className="button-radio">
            <button
              type="button"
              disabled={this.props.readOnly}
              onClick={this.handleOnClick}
              className={inputClasses}>
              <i className={iconClasses}></i> {this.props.title}
            </button>
            <input
              ref="radio"
              type="radio"
              name={this.props.group}
              value={this.props.name}
              checked={checked}
              onChange={this.handleOnChange}
              className="hidden" />
          </span>
        </div>
      </div>
    );
  }
});

module.exports = ConfigFieldRadio;
