var classNames = require('classnames');
var React = require('react');

var FileInput = React.createClass({
  getInitialState: function() {
    return {
      errText: ''
    };
  },

  handleOnChange: function(e) {
    this.setState({errText: ''});

    var reader = new FileReader();
    reader.onload = function() {
      var vals = reader.result.split(',');
      if (vals.length !== 2) {
        this.setState({errText: 'invalid file data'});
        return;
      }
      // this.refs.file.getDOMNode().value = '';
      if (this.props.onChange) {
        this.props.onChange(file.name, vals[1]);
      }
    }.bind(this);

    var file = e.target.files[0];
    reader.readAsDataURL(file);
  },

  render: function() {
    var classes = classNames(this.props.className, 'btn btn-default btn-file', {
      'readonly': this.props.readOnly === true,
      'disabled': this.props.disabled === true
    });

    return (
      <span>
        <span className={classes}>
          <i className="glyphicon glyphicon-file"></i> {this.props.label || 'Choose file'}
          <input
            ref="file"
            type="file"
            name={this.props.name}
            className="form-control"
            onChange={this.handleOnChange}
            readOnly={this.props.readOnly}
            disabled={this.props.disabled} />
        </span>
        <small className="text-danger"> {this.state.errText}</small>
      </span>
    );
  }
});

module.exports = FileInput;
