var yaml = require('js-yaml');
var React = require('react');

var Configure = React.createFactory(require('../components/Configure.jsx'));

module.exports = {
  renderYml: function(yml, component, changeHandler) {
    var doc = yaml.safeLoad(yml);
    React.render(
      Configure({groups: doc.config, handleChange: changeHandler}),
      component
    );
  },

  renderYmlToString: function(yml, cb) {
    var doc;
    try {
      doc = yaml.safeLoad(yml);
    } catch(e) {
      cb(e, null);
    }
    var c = Configure({groups: doc.config});
    var html = React.renderToString(c);
    cb(null, html);
  }
};
