var semver = require('semver');

var pjson = require('../package.json');

var version = '0.9.0';

var Compat = {
  setVersion: function(v) {
    version = v;
  },

  c: function(min) {
    return semver.gte(version, min);
  },

  hiddenClass: function(min, size) {
    return this.c(min) ? '' : 'hidden' + (size ? '-' + size : '');
  },

  visibleClass: function(min, size) {
    return this.c(min) ? 'visible' + (size ? '-' + size : '') : '';
  }
}

module.exports = Compat
